unit Unit1;
//http://www.phidels.com
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    ButtonCacheAltCtrlSup: TButton;
    ButtonCacheBarreTache: TButton;
    ButtonVisibleAltCtrlSup: TButton;
    ButtonVisibleBarreTache: TButton;
    procedure ButtonCacheAltCtrlSupClick(Sender: TObject);
    procedure ButtonCacheBarreTacheClick(Sender: TObject);
    procedure ButtonVisibleAltCtrlSupClick(Sender: TObject);
    procedure ButtonVisibleBarreTacheClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Function CacheAltCtrlSup(Cache:Boolean):Boolean;
{---------------------------------------------------------------}
{ si cache est  true : Cache l'application d'un Alt-Ctrl-Suppr }
{ si cache est  false : rend l'application visible             }
{ Utilisation de RegisterServiceProcess situ dans kernel32.dll }
{ voir le tutorial sur les dll pour plus de comprhension       }
{---------------------------------------------------------------}
Const
  RSP_UNREGISTER_SERVICE=1;
  RSP_REGISTER_SERVICE  =0;
var
  handle : HMODULE;
  RegisterServiceProcess : function(dwProcessId: DWORD; dwType: DWORD) : DWORD; stdcall;
begin
  Handle := LoadLibrary('krn386.exe');
  if Handle = 0 then Handle:=LoadLibrary('kernel32.dll');
  if Handle <> 0 then
  begin
    @RegisterServiceProcess := GetProcAddress(Handle, 'RegisterServiceProcess');
    if @RegisterServiceProcess <> nil then
    begin
      if Cache then RegisterServiceProcess(0, RSP_UNREGISTER_SERVICE )//Cache du Alt Ctrl Sup
      else          RegisterServiceProcess(0, RSP_REGISTER_SERVICE   )//Rend visible du Alt Ctrl Sup
    end;
    FreeLibrary(Handle);
  end;
end;

procedure TForm1.ButtonCacheAltCtrlSupClick(Sender: TObject);
{------------------------------------------------}
{     Cache l'application d'un Alt-Ctrl-Suppr    }
{------------------------------------------------}
begin
  CacheAltCtrlSup(True);
end;

procedure TForm1.ButtonVisibleAltCtrlSupClick(Sender: TObject);
{---------------------------------------------------------}
{     Ne plus Cacher l'application d'un Alt-Ctrl-Suppr    }
{---------------------------------------------------------}
begin
  CacheAltCtrlSup(False);
end;

procedure TForm1.ButtonCacheBarreTacheClick(Sender: TObject);
{------------------------------------------------}
{  Cache l'application dans la barre des tches  }
{------------------------------------------------}
begin
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TForm1.ButtonVisibleBarreTacheClick(Sender: TObject);
{-------------------------------------------------------}
{  rend visible l'application dans la barre des tches  }
{-------------------------------------------------------}
begin
  ShowWindow(Application.Handle, SW_NORMAL);
end;

end.
